Subject: bug#10396: 24.0.92; update-directory-autoloads now adds path element to filename in autoload definition

From: David Engster <[email-masked]>
Date: Sat, 28 Jan 2012 19:41:44 +0100

Chong Yidong writes:
> David Engster <[email-masked]> writes:
>
>> Stefan Monnier writes:
>>>> This might not be a bug, but I couldn't find anything in NEWS regarding
>>>> this issue, and it breaks my personal autoload setup.
>>>
>>> It's a feature: since foo/bar is not in `load-path', autoload.el figures
>>> that only "bar/test" will properly load the file.
>>> So you just need to set `load-path' to include `foo/bar' like you
>>> probably already do elsewhere.
>>
>> But it's a new feature, right? Emacs 23.3 doesn't seem to do that.
>>
>> If it's new, I think it should be mentioned in NEWS; it is an important
>> change for anyone creating Emacs packages, since I now have to make sure
>> that `load-path' during autoload-generation and during actual usage of
>> the package is consistent.
>
> Could you suggest a NEWS entry?  That would be helpful, since I don't
> understand how the current autoload behavior breaks your setup.

Here's a suggestion:

When generating autoloads, `update-directory-autoloads' now longer
assumes that every inspected file will be in your `load-path', but will
now generate relative names according to your current `load-path' setting.

Stefan, please correct me if this is not a proper description of the new
behavior.  Also, I'm not sure if this new feature only affects
`update-directory-autoloads', but also other autoload functions.

-David